var backWidth = 220;
var backHeight = 290;
var frontWidth = 200;
var frontHeight = 200;
var backShown = false;

var tableTd = ["tc", "tr", "lc", "rc", "bl", "bc"];
var tableImg = ["tl", "br"];
var titleColors = {white: "black", yellow: "black", orange: "black", gray: "black"};
var backColors = {black: "#202020", white: "white", red: "#b90a0a", orange: "#d97505", yellow: "#E7C24A", green: "#28970e", blue: "#1f289e", gray: "#9f9f9f"};

var urls = new Array();
var lastId = 0;
var usePath = false;

function setup() {
  widgetSetup();
  frontWidth = window.innerWidth;
  frontHeight = window.innerHeight;
  if (window.widget) {
    if (widget.mobile) {
      var fit = widget.mobile.getResizeToFit();
      frontWidth = 274;
      frontHeight = 600;
    }
    
    widget.onshow = onshow;
    widget.onhide = onhide;
    widget.onremove = clearPrefs;
    readPrefs();
    if (widget.context != null) {
      document.getElementById("Widgetop").style.display = "none";
    }
  }
  
}

function onshow() {
}

function onhide() {
}

function readPrefs() {
  var ids = widget.preferenceForKey(widget.identifier + "-urls");
  if (ids) {
    urls = eval(ids);
  }
  alert(urls);
  if (urls.length > 0) {
    for (var i = 0; i < urls.length; i++) {
    	var url = widget.preferenceForKey(widget.identifier + "-url" + urls[i]);
    	addUrlImage(url, urls[i]);
    	if (lastId < urls[i]) {
    	  lastId = urls[i];
    	}
    }
  }
  else {
    addUrlImage("http://en.wikipedia.org");
    addUrlImage("http://www.youtube.com");
    addUrlImage("http://www.imdb.com");
    addUrlImage("http://www.amazon.com/gp/redirect.html?ie=UTF8&location=http%3A%2F%2Fwww.amazon.com%2F&tag=iphon-20&linkCode=ur2&camp=1789&creative=9325");
    addUrlImage("http://www.apple.com");
    if (widget.context) {
      addUrlImage("http://widgetop.wordpress.com");          
    }
    else {         
      addUrlImage("http://www.widgetop.com");    
    }  
  }
  var width = widget.preferenceForKey(widget.identifier + "-width");
  if (width != null) {
    frontWidth = eval(width);    
  }
  var height = widget.preferenceForKey(widget.identifier + "-height");
  if (height != null) {
    frontHeight = eval(height);    
  }    
  resize(frontWidth, frontHeight);

  var value = widget.preferenceForKey(widget.identifier + "-color");
  if (value != null) {
    setFrontColor(value);
    document.getElementById("FrontColor").value = value;    
  }
  else {
    setFrontColor("black");
  }

  if (this.showBackSide) {
    showBack()
  }
}

function clearPrefs() {
  for (var i = 0; i < urls.length; i++) {
    widget.setPreferenceForKey(null, widget.identifier + "-url" + urls[i]);  	
  }
  widget.setPreferenceForKey(null, widget.identifier + "-urls");
  widget.setPreferenceForKey(null, widget.identifier + "-width");
  widget.setPreferenceForKey(null, widget.identifier + "-height");
  widget.setPreferenceForKey(null, widget.identifier + "-color");
}

function addUrl() {
  addUrlImage(document.getElementById("UrlInput").value);
}

function addUrlImage(url, id) {
  if (!id) {
    lastId++;
    id = lastId;
    urls.push(id);
  }
  widget.setPreferenceForKey(url, widget.identifier + "-url" + id);  	  
  saveUrls();
  var element = document.createElement("div");
  element.id = "Url" + id;
  element.urlId = id;  
  element.className = "url";
  element.title = "Open " + url;
  var img = document.createElement("img");
  img.className = "urlImage";
  img.width = 100;
  img.height = 75;
  img.src = "loading.gif";
  img.onclick = function() {
    widget.openURL(url);
  }
  if (url && url.indexOf("widgetop") >= 0) {
    img.src = "widgetop.png";    
  }
  else {
    var result = url;
    if (!usePath) {
      var index = url.indexOf(":");
      if (index >= 0) {
        index = url.indexOf("/", index + 3);
        if (index >= 0) {
          result = url.substring(0, index);
        }
      }
    }
    img.src = "http://images.websnapr.com/?url=" 
      + encodeURIComponent(result) 
      + "&size=S";
  }
  element.appendChild(img);
  var closeBtn = document.createElement("div");
  closeBtn.className = "closeButton";
  closeBtn.onclick = function() {
    removeUrlImage(element);
  }
  closeBtn.title = "Close";
  element.appendChild(closeBtn);
  element.onmouseover = function() {
    closeBtn.style.display = "inline";
  }
  element.onmouseout = function() {
    closeBtn.style.display = "none";
  }
  document.getElementById("Marks").appendChild(element);
}

function removeUrlImage(element) {
  var id = element.urlId;
  widget.setPreferenceForKey(null, widget.identifier + "-url" + id);  	
  for (var i = 0; i < urls.length; i++) {
  	if (urls[i] == id) {
  	  urls.splice(i, 1);
  	}
  }
  saveUrls();
  element.parentNode.removeChild(element);
}

function saveUrls() {
  var code = "[";
  for (var i = 0; i < urls.length; i++) {
  	if (i > 0) {
  	  code += ",";
  	}
  	code += urls[i];
  }
  code += "]";
  widget.setPreferenceForKey(code, widget.identifier + "-urls");  	  
}

function onEnter(event) {
  var keyCode = null;

  if( event.which ) {
    keyCode = event.which;
  } else if( event.keyCode ) {
    keyCode = event.keyCode;
  }
  if( 13 == keyCode ) {
    addUrl();
  }
}

function resize(width, height) {
  window.resizeTo(width, height);
  document.getElementById("Background").style.width = width + "px";
  document.getElementById("Background").style.height = height + "px";  
}

function onresize() {
  if (!backShown) {
    if (window.widget) {
      widget.setPreferenceForKey("" + window.innerWidth, widget.identifier + "-width");
      widget.setPreferenceForKey("" + window.innerHeight, widget.identifier + "-height");
    }      
  }
}

function setFrontColor(color) {
  var prefix = "back"
  for (var i = 0; i < tableTd.length; i++) {
  	var element = document.getElementById("Table_" + tableTd[i]);
  	element.setAttribute("background", prefix + "_" + tableTd[i] + "_" + color + ".png");
  }
  for (var i = 0; i < tableImg.length; i++) {
  	var element = document.getElementById("Table_" + tableImg[i]);
  	element.src = prefix + "_" + tableImg[i] + "_" + color + ".png";
  }
  document.getElementById("Table_c").style.backgroundColor = color;
  if (titleColors[color] != null) {
    document.getElementById("Title").style.color = titleColors[color];
    document.getElementById("AddUrl").style.color = titleColors[color];
  }
  else {
    document.getElementById("Title").style.color = null;    
    document.getElementById("AddUrl").style.color = null;    
  }
  if (backColors[color] != null) {
    document.getElementById("Table_c").style.backgroundColor = backColors[color];
  }
  else {
    document.getElementById("Table_c").style.backgroundColor = color;    
  }
  widget.setPreferenceForKey(color, widget.identifier + "-color");
}

function updateFront(){
  var color = document.getElementById("FrontColor").value;
  setFrontColor(color);
  widget.setPreferenceForKey(color, widget.identifier + "-color");
  
  window.resizeTo(frontWidth, frontHeight);  
}

function showHelp() {
  document.getElementById("Help").style.display = "block";
}

function closeHelp() {
  document.getElementById("Help").style.display = "none";  
}

function widgetSetup() {
  if (window.widget) {
  	var gAddButton = new AppleGlassButton(document.getElementById("AddButton"), 
  	                                      "+", addUrl); 
  	var gDoneButton = new AppleGlassButton(document.getElementById("DoneButton"), 
  	                                      "Done", hideBack); 
	  var gInfoButton = new AppleInfoButton(document.getElementById("InfoButton"), 
	                                        document.getElementById("front"), 
	                                        "black", "white", showBack);
	  gInfoButton.setCircleOpacity(0.8);                                          
	  var resizeButton = new Resizer(window, 
	                                 document.getElementById("ResizeButton"),
	                                 document.getElementById("Background"), onresize);    
  }
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if(window.widget)
        widget.prepareForTransition("ToBack");
 
    backShown = true;
    front.style.display="none";
    frontWidth = window.innerWidth;
    frontHeight = window.innerHeight;
    window.resizeTo(backWidth, backHeight);
    back.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
 
    if (window.widget)
        widget.prepareForTransition("ToFront");
 
    backShown = false;
    back.style.display="none";
    updateFront();
    front.style.display="block";
 
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}  